	//	Program 7.2
	//	tic-tac-toe

	#include <iostream.h>
	#include <conio.h>				//for clrscr();

	int player, row, col, winner = 0;
	char grid[3][3] = { {' ', ' ', ' '},  	//game board 3x3 initialized
			 			           {' ', ' ', ' '},	//to spaces
						           {' ', ' ', ' '} };

	void welcome();
	void showGameBoard();
	void checkForWin();

	void main()
	{
		welcome();

		for (int count = 0; count < 9 && winner == 0; count++)
		{
			showGameBoard();						  //display grid
			player = (count % 2) + 1;    //select player 1 or 2

			do
			{
				do						 //player enters row number - note error checks
				{
					cout << "\n\nPlayer " << player << " please enter row number: ";
					cin >> row;
				}while(row < 0 || row > 3);

				row -= 1;

				do	            //	player enters column number - note error checks
				{
					cout << "Player " << player << " please enter column number: ";
					cin >> col;
				}while(col < 0 || col > 3);

				col -= 1;

				if(grid[row][col] == 'X' || grid[row][col] == 'O')	//check if space
					cout << "\nThis space is occupied.  Try again.";	//occupied

			}while(grid[row][col] == 'X' || grid[row][col] == 'O');

			grid[row][col] = (player == 1) ? 'X' : 'O';

			checkForWin();											//check if player has won
		}																				// loop continues until
																						// nine moves or a win	

		showGameBoard();															// After game completed
		if(winner == 0)															// show final board and
			cout << "\n\nThe game is a draw";								// announce win or lose
		else
			cout << "\n\nPlayer " << player << " is the winner\n\n";
	}

	void welcome()
	{ /* Simple function to display welcome message and instructions */


		cout << "\n\n\tWelcome to the game of tic-tac-toe\n" 
			  << "\tThis is a game for two players and the computer will ask\n"
			  << "\tEach player to input their row and column number.\n"
			  << "\tThe computer shows whether the game has been won or drawn.\n";

   cout << "\n\n\tPress any key to continue .....";
	   getch();
}

	void showGameBoard()
	{ /* This function clears screen and draws revised grid to screen */
		clrscr();

		cout << endl << endl
			 << "\t " << grid[0][0] << " | " << grid[0][1] << " | " 
    << grid[0][2] << " \n"
			 << "\t-----------\n"
			 << "\t " << grid[1][0] << " | " << grid[1][1] << " | " 
    << grid[1][2] << " \n"
			 << "\t-----------\n"
			 << "\t " << grid[2][0] << " | " << grid[2][1] << " | " 
    << grid[2][2] << " \n" << endl << endl;
	}

	void checkForWin()
	{ /* This function checks for a win by comparing lines, rows, and
     diagonals for three of the same symbols */

		for (int line = 0; line < 3; line++)
		{
			if(grid[line][0] == 'X' &&  grid[line][1] == 'X' && grid[line][2] == 'X')
				winner = player;
			if(grid[line][0] == 'O' &&  grid[line][1] == 'O' && grid[line][2] == 'O')
				winner = player;
			if(grid[0][line] == 'X' &&  grid[1][line] == 'X' && grid[2][line] == 'X')
				winner = player;
			if(grid[0][line] == 'O' &&  grid[1][line] == 'O' && grid[2][line] == 'O')
				winner = player;
		 }
		 if(grid[0][0] == 'X' && grid[1][1] == 'X' && grid[2][2] == 'X')
			winner = player;
		 if(grid[0][0] == 'O' && grid[1][1] == 'O' && grid[2][2] == 'O')
			winner = player;
		 if(grid[0][2] == 'X' && grid[1][1] == 'X' && grid[2][0] == 'X')
			winner = player;
		 if(grid[0][2] == 'O' && grid[1][1] == 'O' && grid[2][0] == 'O')
			winner = player;
	}