// Program 7.6b
// File 2 Functions for tic-tac-toe

#include <iostream.h>
#include <conio.h>        //for clrscr();

  void welcome()
  { /* Simple function to display welcome message and instructions */

  	 cout << "\n\n\tWelcome to the game of tic-tac-toe\n"
		     << "\tThis is a game for two players and the computer will ask\n"
		     << "\tEach player to input their row and column number.\n"
		     << "\tThe computer shows whether the game has been won or drawn.\n";

	    cout << "\n\n\tPress any key to continue ..... ";
	    getch();
  }

  void showGameBoard(char g[3][3])
  { /* This function clears screen and draws revised grid to screen */
	    clrscr();

    cout << endl << endl
	         << "\t " << g[0][0] << " | " << g[0][1] << " | " 
          << g[0][2] << " \n"
	         << "\t-----------\n"
	         << "\t " << g[1][0] << " | " << g[1][1] << " | " 
          << g[1][2] << " \n"
	         << "\t-----------\n"
	         << "\t " << g[2][0] << " | " << g[2][1] << " | " 
          << g[2][2] << " \n" << endl << endl;
  }

  void enter_move(char g[3][3], int p)
  {
	    int row;
	    int col;

	    do
	    {
		    do                  //player enters row number - note error checks
		    {
		      cout << "\n\nPlayer " << p << " please enter row number: ";
		      cin >> row;
		    }while(row < 0 || row > 3);

		    row -= 1;

		    do                //  player enters column number - note error checks
		    {
		      cout << "Player " << p << " please enter column number: ";
		      cin >> col;
       }while(col < 0 || col > 3);

		    col -= 1;

		    if(g[row][col] == 'X' || g[row][col] == 'O')          //check if space
		      cout << "\nThis space is occupied.  Try again.";    //occupied

	    }while(g[row][col] == 'X' || g[row][col] == 'O');

	    g[row][col] = (p == 1) ? 'X' : 'O';
  }

  void checkForWin(char g[3][3], int &w, int p)
  { /* This function checks for a win by comparing lines, rows, and 
    diagonals for three of the same symbols -  note this function as been
    modified slightly.  There is no need to check if both players have won 
    after each move.  We now only check if the current player has won   */

	    if (p == 1)
	    {
		    for (int line = 0; line < 3; line++)
		    {
			    if(g[line][0] == 'X' &&  g[line][1] == 'X' && g[line][2] == 'X')
				    w = p;
			    if(g[0][line] == 'X' &&  g[1][line] == 'X' && g[2][line] == 'X')
				    w = p;
		    }
		    if(g[0][0] == 'X' && g[1][1] == 'X' && g[2][2] == 'X')
			    w = p;
		    if(g[0][2] == 'X' && g[1][1] == 'X' && g[2][0] == 'X')
			    w = p;
	    }
	    else
	    {
		    for (int line = 0; line < 3; line++)
		    {
			    if(g[line][0] == 'O' &&  g[line][1] == 'O' && g[line][2] == 'O')
				    w = p;
			    if(g[0][line] == 'O' &&  g[1][line] == 'O' && g[2][line] == 'O')
				    w = p;
		    }
		    if(g[0][0] == 'O' && g[1][1] == 'O' && g[2][2] == 'O')
			    w = p;
		    if(g[0][2] == 'O' && g[1][1] == 'O' && g[2][0] == 'O')
			    w = p;
	    }
  }

  void display_result(int w, char g[3][3])
  {
	    showGameBoard(g);                              // After game completed
	    if(w == 0)                                     // show final board and
	      cout << "\n\nThe game is a draw";            // announce win or lose
    else
	      cout << "\n\nPlayer " << w << " is the winner\n\n";
  }