//	textanal.cpp
//	a program to analyze the number of letters in words
//	and words in sentences

#include <iostream.h>   //header file for I/O
#include <conio.h>			//header file for getch()
#include <ctype.h>			//header file for isalpha()

void main()
{
  void analyze(void);
  char answer = 'N';

	  clrscr();					//clear the screen

	  cout << "\n\t\t ANALYZING TEXT ENTERED VIA THE KEYBOARD \n"
	       << "\t\t *************************************** \n\n"
	       << "\n\tThis program analyzes text entered via the keyboard"
	       << "\n\tand reports on the number of letters in words and the"
	       << "\n\tnumber of words in a sentence.\n\n";

	  do            //this loop repeats, and allows the user to analyze more
	  {             //  text, until the user does not enter Y or y
		  analyze();  //calls analyze function

                  //ask user if they want another go
		  cout << "\n\tDo you want to analyze some more text? (Y/N) ";
		  cin >> answer;            //users response

	  } while(answer == 'Y' || answer == 'y');//repeat loop if Y or y entered
}

void analyze()                  //function to analyse text
{
//function prototype - this function displays the results
void results(int l[], int n[], int s);

char character = ' ';				     //character being analyzed
char previous_character = ' ';	 //previous character analyzed
int letters = 0, i;
int words = 0, sentences = 0;
int length[21];
int no_of_words[21];

	  for(i = 0; i <= 20; i++)		 //initialize arrays
	  {
		  length[i] = 0;
		  no_of_words[i] = 0;
	  }

	  cout << "\n\tPlease enter your text which should be terminated"
	       << "\n\tby leaving a space and then typing *.\n\n";

  cin.get(character);          //get first character

  while(character != '*')      //repeat loop until * entered
	  {
		  if(isalpha(character))   //is character a letter
			  letters++;             //  if so increase count
		  else                     //  if not
		  {
			  if(letters > 20)       //   if letters greater than 20
				  letters = 20; //  assign letters value 20 (for display and array)
			  length[letters]++; // increment element corresponding to length
			  letters = 0;       //   re-initialize variable 
		  } 
     
     //if previous character a letter and currenet one isnt ...
		  if((isalpha(previous_character)) && (!isalpha(character)))
			  words++;           // ... increment word

		  if(character == '.' || character == '!' || character == '?'
			                   || character == '*')
		  {//if character terminates a sentence, i.e. . ! ? or *
			  if(words > 20)     //if words greater than 20
				  words = 20;     //  assign words value 20 (for display and array)
			  no_of_words[words]++;  //  ++ element corresponding to no of words
			  words = 0;             //  re-initialize variable
			  sentences++;           //  increment count of sentences
		  }
		  previous_character = character; 
		  cin.get(character);        //get new character
  }                             //loop will repeat unless * entered

	  clrscr();					           //clear screen

	  results(length, no_of_words, sentences);	//display results
}


void results(int length[], int no_of_words[], int sentences)
{
	int i;
	float total = 0.0, total1 = 0.0, mean = 0.0;

	  cout << "Number of Characters" << "\t"
	       << "Number of Words \n";

	  for(i = 1; i <=20; i++)
		  cout << i << "\t\t\t\t" << length[i] << endl;

	  cout << "\n\t Press any key to continue ... ";
	  getch();			//wait until a key is pressed

	  clrscr();

	  cout << "Number of words in sentence"
	       << "\t Number of occurrences \n";

	  for(i = 1; i <= 20; i++)
		  cout << i << "\t\t\t\t\t" << no_of_words[i] << endl;

	  cout << "\n\t Press any key to continue ... ";
	  getch();			//waits until a key is pressed

	  clrscr();

	  cout << "The total number of sentences processed was : "
	       << sentences << endl;

  for(i = 1; i <= 20; i++)
	  {
		  total  += length[i];
		  total1 += (i * length[i]);
	  }

  mean = total1 / total;

	  cout << "\n\nThe average word size is " << mean << " letters."
	       << "\n\nThe total number of words is " << total << "."
	       << "\n\n\tPress any key to continue ... ";
	  getch();
}