// Program 8.5
// Processing text files: counting characters
#include <iostream.h>

//  Global data
// Numbers of chars in stream
long  BlankTabs,  // Blank + Tab
  NewLines,       // NewLine
  Semicolons,     // ;
  Slashes,        // /
  Others;         // All other chars

//  Function declarations
void  SayAboutUsage  (void);
void  Count    (char Char);
int  Err_or_EOF  (void);
void  SayAboutChars  (void);

void main () 
{
  char  Char = '!';

  SayAboutUsage ();

  cin.unsetf (ios::skipws);   // Not to skip whitespace
  while (1) 
  {
      cin >> Char;            // Get from stream
      if (Err_or_EOF ()) 
          break;              // Exit on error or EOF
      Count (Char);           // Count chars
  }
  SayAboutChars ();
}

void SayAboutUsage(void) 
{
  cerr << "\nCounting characters:\n\n"
          "File input:\n\n"
          "  P08_05 < any_text_file\n\n"
          "Console input:\n"
          "  Input text strings ending with Enter\n"
          "  Enter ^Z (Ctrl/Z) to exit\n";
}

int Err_or_EOF(void) 
{//this function returns non-zero if an error is detected 
 //or if the end-of-file is detected.

  int status = 0;
  if( cin.eof() ) 
    status = -1;
  else
      if ( cin.bad() ) 
    {
          cerr << "Input error\n";
          status = -2;
      }
  return status;
}

void Count(char Char) 
{
  switch (Char) 
  {
      case ' ' :
      case '\t': 
        BlankTabs++;  
        break;
      case '\n': 
        NewLines++;  
        break;
      case ';' : 
        Semicolons++;  
        break;
      case '/' : 
        Slashes++;
        break;
      default  : 
        Others++;
  }
}

void SayAboutChars(void) 
{
  long Whitespaces = 2 * NewLines + BlankTabs;
  /* Every pair of chars
     Carriage Return and Line Feed
     is translated by >> into one
  */
  long Comments = Slashes/2;  // Not too precise
  long Total = Whitespaces + Semicolons + Slashes + Others;

  cout << "\nFile has:\n\n" << " Total characters " << Total  
       << endl << "  Lines            " << NewLines << endl
       <<  "  Whitespaces      " << Whitespaces << endl
       <<  "  Statements       " << Semicolons  << endl
       <<  "  Comments         " << Comments  << endl;
}
// EOF