//  Program 8.6  P08_06.CPP
//  Counting words with old I/O stream functions
#include <stdio.h>

//  Global data
                   // Numbers of:
long  BlankTabs,   // Blank + Tab
  NewLines,        // NewLine
  Fullstops,       // End of sentence
  Others,            // All other chars
  Words;             // whitespace delimitered words

//  Function declarations
void  SayAboutUsage  (void);
void  Count    (char Char);
void  SayAboutChars  (void);

void main() 
{
  int IChar = 0;

  SayAboutUsage();
  while (1) 
  {
      IChar = getchar ();         // Get from stream
      if (IChar == EOF) 
        break;                    // Exit on EOF
      Count ((char)IChar);        // Count chars
  }

  SayAboutChars();
}

void SayAboutUsage(void) 
{
  printf ("\nCounting characters, words and sentences:\n\n"
          "File input:\n\n"
          "  P08-06 < any_text_file\n\n"
          "Console input:\n"
          "  Input text strings ending with Enter\n"
          "  Enter ^Z (Ctrl/Z) to exit\n" );
}

void Count(char Char) 
{  /*  Count chars and words
    Flag InWord has value No if Char is whitespace
      Yes - otherwise
    Static variable WasInWord remember
      previous InWord value    */

  const  int No        = 0;
  const  int Yes       = 1;
  static int WasInWord = No;       // Where was
         int InWord    = Yes;      // Where now

  switch (Char) 
  {
      case ' ' :
      case '\t': 
        BlankTabs++;  
        InWord=No;  
        break;
      case '\n': 
        NewLines++;   
        InWord=No;  
        break;
      case '.' : 
        Fullstops++;      
        break;
      default  : 
        Others++;
  }

  if (InWord && !WasInWord) 
    Words++;
  WasInWord = InWord;        // Save for next entry
}

void SayAboutChars(void) 
{
  long Whitespaces = 2 * NewLines + BlankTabs;
  /* Every pair of chars
     Carriage Return and Line Feed
     is translated by getchar () into one char
  */
  long Total = Whitespaces + Fullstops + Others;

  printf ("\nFile has:\n\n");
  printf ("  Total characters %ld\n", Total);
  printf ("  Whitespaces      %ld\n", Whitespaces);
  printf ("  Words            %ld\n", Words);
  printf ("  Sentences        %ld\n", Fullstops);
  printf ("  Lines            %ld\n", NewLines);
}
// EOF