//  Program 8.16
//  Random read/write demo
#include <stdlib.h>       //for exit() and rand()
#include <fstream.h>      //for fileI/O
#include <ctype.h>        //for islower(), toupper(), etc
#include <iomanip.h>      //for I/O manipulators
#include <string.h>       //for strcpy()

long N = 1000;            // Number of reads/writes
int ReverseCaseFlag = 0;  // Not change letter case

void filename ( char * );
void Indicator(void);
void Print(long Count []);

void main()
{
  long FileLen;           // File length
  long Count [256]={0};   // Array for counting chars
  char FName[128];        // Place for file name

  cout << "\nCounting statistical distribution of characters in file\n\n";

  filename(FName);      // Get file name and open

  fstream discfile;

  discfile.open(FName, ios::app | ios::in | ios::out | ios::binary);
  // Note the vertical bars indicate that the mode bits are being
  // ORd together so that several flags can be used simultaneously

  discfile.seekg(0, ios::end);    // Set file to its end
  FileLen = discfile.tellg();     // Get file length

  for (long i=0; i<N; i++)        //Repeat file access N times
  {
    unsigned char  C;             // Current char
    long Pos;                     // Current position

    Pos = rand() % FileLen;       // Random Pos from 0 to FileLen
    discfile.seekg(Pos);          // Move file pointer
    discfile.get(C);              // Read 1 byte
    if(discfile.bad())
      exit (-1);                   // Exit on error

    if (ReverseCaseFlag)
    { // Reverse case of letter only for p08-16.tst file
      if (islower(C))
        C=toupper(C);
      else
        C=tolower(C);

      discfile.seekp(Pos);        // Return to previous position
      discfile.put(C);            // Write 1 byte
      if(discfile.bad())
        exit (1);                 // Exit on error
    }
    Count[tolower(C)]++;          // Increment for current char
    Indicator ();                 // Progress indicator
  }
  Print (Count);                  // Output results
}

void filename(char * name)
{/*  Get file name from console
  and open file in binary mode for read and write

  If file not exists then file "p08_16.tst" is used
  (if it is not exists, it is created)
  When file "p08_16.tst" is used,
  the ReverseCaseFlag is set to 1
  and case of letters will be reversed  */

  cout << "Enter file name (if not exist - p08-18.tst will be used): ";
  cin  >> name;

  ifstream input(name, ios::in | ios::binary );
  if (!input)
  { // Test file name
    char TestName[128]="p08_16.tst";

    ReverseCaseFlag = 1;  // Letter case will be changed

    cout << "File " << name << " not found\n";

    ofstream output(TestName, ios::in | ios::out | ios::binary | ios::app);
    if (output)
    { // Create and open test file
      char Line [] =  "ABCDEFGHIJKLMNOPQRSTUVWXYZ";
      if (! output)             //test file line
        exit (-1);

      cout << "Creating file " << TestName << endl;
      output << Line;
      output.close();
    }
    cout << "Test file " << TestName << " is used\n";
    strcpy(name, TestName);
  }
  cout << "Enter number of seeks (1-100000): ";
  cin  >> N;
  if (N < 1L || N > 100000L)
  {
    N = 1000;
    cout << "Value is out of range, 1000 is used\n";
  }
  input.close();
}

void Indicator(void)
{/*  Output Progress_Indicator character
  for every Progress_Count bytes read  */

    static int Count=0;
    char Progress_Indicator = '.';
    int  Progress_Count = 100;

  if ( !(++Count % Progress_Count) )
    cout << Progress_Indicator;
}

void Print(long Count [])
{
  long Sum = 0;
  int  i = 0;
  unsigned char C = 0;

  for (Sum=0,i=0; i < 256; i++)
    Sum += Count [i];
  cout << "\nTotal characters:\t" << Sum << endl;

  for (Sum = 0, C = 'a'; C <= 'z';  C++)
    Sum += Count [C];
  cout << "Alpha characters aA to zZ:\t " << Sum << endl << endl;

  cout << setw(8) << "Char" << setw(8) << "Q-ty" << setw(8) << "%"
       << setw(8) << "Char" << setw(8) << "Q-ty" << setw(8) << "%"
       << endl << endl;

  for (C = 'a'; C <= 'z'; C++)
  {
    cout << setw(8) << C << setw(8) << Count[C] << setw(8)
         << (100. * Count[C]) / Sum;
    if((C - 'a') % 2)
      cout << endl;      // Next line
  }
}