//  book.cpp
//  a program to store details of books to a disc file  

#include <fstream.h>       //header file for file i/o
#include <stdio.h>         //header file for gets()
#include <conio.h>         //header file for clrscr(), getch()
#include <dos.h>           //header file for sleep()

struct data
{
char title[50];
char author[30];
char publisher[30];
int date;
char isbn[15];
float price;
};


data book;
int number, record, position;
fstream library;

void main()
{
  void enter_data(data&);
  void display_data(data&);
  int menu();
  void add();
  void read_rec();
  void read();

  do
  {
    number = menu();
    switch(number)
    {
      case 1:
        add();
        break;
      case 2:
        read_rec();
        break;
      case 3:
        read();
        break;
      case 4:
        clrscr();
        cout << "The program is now ending.";
        break;
      default:
        clrscr();
        cout << "You should enter a number between 1 and 4.  Try again.";
        sleep(6);
    }
  }while(number != 4);
}

int menu()
{
  int select, endOfFile, NoOfRecords;

  clrscr();
  cout << endl << "This program manipulates a file containing details of books\n\n";

  library.open("a:\\books.dat",  ios::in | ios::binary);
  //check for errors
  if(!library)
    cout << "\nCould not open file\n";

  library.seekg(0, ios::end);
  endOfFile = library.tellg();
  NoOfRecords = endOfFile / sizeof(book);

  cout << "At the present time there are " << NoOfRecords
       << " records in the file.\n";
  cout << "\n\t\tDo you wish to\n"
       << "\t1\tAdd a Record\n" << "\t2\tRead a Record\n"
       << "\t3\tRead all Records\n" << "\t4\tExit from the Program\n"
       << "\nEnter number: ";
  cin >> select;

  library.close();
  return(select);
}

void enter_data(data& x)
{
  cout << "\nEnter title: ";
  gets(x.title);
  cout << "Enter author: ";
  gets(x.author);
  cout << "Enter publisher: ";
  gets(x.publisher);
  cout << "Enter date of publication: ";
  cin >> x.date;
  cout << "Enter ISBN number: ";
  gets(x.isbn);
  cout << "Enter price: ";
  cin >> x.price;
}

void display_data(data& x)
{
  cout << endl << x.title << " written by " << x.author << endl
       << "published by " << x.publisher << " in " << x.date << endl
       << "price " << x.price << endl << "ISBN number " << x.isbn
       << endl;
}

void add()
{
  library.open("a:\\books.dat", ios::app | ios::out | ios::binary);

  //check for errors
  if(!library)
    cout << "\nCould not open file\n";

  clrscr();
  enter_data(book);
  library.write((char *) &book, sizeof(book) );
  cout << endl << endl << "Press a key to continue ...";
  library.close();
  getch();
}

void read_rec()
{
  library.open("a:\\books.dat", ios::in | ios::binary);

  //check for errors
  if(!library)
    cout << "\nCould not open file\n";

  clrscr();
  cout << "Which record do you wish to read? ";
  cin >> record;
  cout << endl << endl;
  position = (record - 1) * sizeof(book);
  library.seekg(position);
  library.read((char *) &book, sizeof(book) );
  display_data(book);
  cout << endl << endl << "Press a key to continue ...";
  library.close();
  getch();
}

void read()
{
  library.open("a:\\books.dat", ios::in | ios::binary);

  //check for errors
  if(!library)
    cout << "\nCould not open file\n";

  clrscr();
  library.seekg(0, ios::beg);
  while(library)
  {
    library.read((char *) &book, sizeof(book) );
    if(!library.eof())
      display_data(book);
  }
  cout << endl << endl << "Press a key to continue ...";
  library.close();
  getch();
}