//   addr.cpp
//   a program to store names and addresses to a file

#include <fstream.h>        //header file for file i/o
#include <stdio.h>          //header file for gets()
#include <conio.h>          //header file for clrscr(), getch()
#include <dos.h>            //header file for sleep()

struct data                 //declare structure
{                           //These members are public by default
  char firstnames[30];
  char surname[30];
  char address1[20];
  char address2[20];
  char address3[20];
  char postcode[10];

  int menu();                //function prototypes
  void add();
  void read_rec();
  void read();

private:                      //these members are private
  void enter_data();
  void display_data();
};

int data::menu()       //function to display menu and return users choice
{
  int record, position, select, endOfFile, NoOfRecords;
  fstream address_book;

  clrscr();                   //clear user screen

  cout << endl 
	<< "This program manipulates a file containing names and addresses\n\n";

  address_book.open("addr.dat",  ios::in );      //open disc file
  
  //check for errors
  if(!address_book)
    cout << "\nCould not open file\n";

  address_book.seekg(0, ios::end);   //calculate number of records in file
  endOfFile = address_book.tellg();    //   with these three statements
  NoOfRecords = endOfFile / sizeof(data);

  cout << "At the present time there are " << NoOfRecords
       << " records in the file.\n";

  cout << "\n\t\tDo you wish to\n"                    //display menu
       << "\t1\tAdd a Record\n" << "\t2\tRead a Record\n"
       << "\t3\tRead all Records\n" << "\t4\tExit from the Program\n"
       << "\nEnter number: ";
  cin >> select;                                      //user enters choice

  address_book.close();                               //close disc file

  return(select);               //return users choice for use with switch
}

void data::add()                     //function to add record to disc file
{
  int record, position;
  fstream address_book;

  address_book.open("addr.dat", ios::app | ios::out );   //open file

  //check for errors
  if(!address_book)
    cout << "\nCould not open file\n";

  clrscr();                                                 //clear screen
  enter_data();                                             //call enter data function
  address_book.write((char *) this, sizeof(data) ); //write record to file
  cout << endl << endl << "Press a key to continue ...";
  address_book.close();                                      //close file
  getch();                         //wait on screen until a key is pressed
}

void data::read_rec()                   //function to read record
{
  int record, position;
  fstream address_book;

  address_book.open("addr.dat",  ios::in );        //open file

  //check for errors
  if(!address_book)
    cout << "\nCould not open file\n";

  clrscr();                                             //clear screen
  cout << "Which record do you wish to read? ";
  cin >> record;                              //user enters record number
  cout << endl << endl;
  position = (record - 1) * sizeof(data);//calculate correct position in file
  address_book.seekg(position);               //move to correct record
  address_book.read((char *) this, sizeof(data) );      //read record
  display_data();                            //call display data function
  cout << endl << endl << "Press a key to continue ...";
  address_book.close();                                  //close file
  getch();                         //wait on screen until a key is pressed
}

void data::read()                          //function to read all records
{
  int record, position;
  fstream address_book;

  address_book.open("addr.dat",  ios::in );            //open file

  //check for errors
  if(!address_book)
    cout << "\nCould not open file\n";

  clrscr();                                           //clear user screen
  address_book.seekg(0, ios::beg);             //go to beginning of file
  while(address_book)                          //while not at end of file
  {                                            //  or some other error
    address_book.read((char *) this, sizeof(data) );       //read record
    if(!address_book.eof())  //to prevent last record being output twice
      display_data();                                       //display data
  }
  cout << endl << endl << "Press a key to continue ...";
  address_book.close();                                      //close file
  getch();                         //wait on screen until a key is pressed
}

void data::enter_data()                         //function to enter data
{
  cout << "\nEnter first names: ";
  gets(firstnames);
  cout << "Enter surname: ";
  gets(surname);
  cout << "Enter first line of address: ";
  gets(address1);
  cout << "Enter second line of address: ";
  gets(address2);
  cout << "Enter third line of address: ";
  gets(address3);
  cout << "Enter postcode: ";
  gets(postcode);
}

void data::display_data()                       //function to display data
{
  cout << endl << firstnames << " " << surname << endl
       << address1 << endl << address2 << endl << address3
       << endl << postcode << endl << endl;
}

void main()
{
  data address;
  int number;

  do
  {
    number = address.menu();   //call menu function and use returned value
                               //in switch statement
    switch(number)
    {
      case 1:
        address.add();
        break;

      case 2:
        address.read_rec();
        break;

      case 3:
        address.read();
        break;

      case 4:
        clrscr();
        cout << "The program is now ending.";
        break;

      default:
        clrscr();
        cout << "You should enter a number between 1 and 4. Try again.";
        sleep(6);
    }
  }while(number != 4);
}