//    addr2.cpp
//    a program to store names and addresses to a file

#include <fstream.h>        //header file for file i/o
#include <stdio.h>          //header file for gets()
#include <conio.h>          //header file for clrscr(), getch()
#include <dos.h>            //header file for sleep()

class data                  //class declaration
{
public:                     //these members are public
  char firstnames[30];
  char surname[30];
  char address1[20];
  char address2[20];
  char address3[20];
  char postcode[10];

  int menu();
  void add();
  void read_rec();
  void read();

private:                    //these members are private
  void enter_data();
  void display_data();
};

int data::menu()
{
  int record, position, select, endOfFile, NoOfRecords;
  fstream address_book;

  clrscr();

  cout << endl << "This program manipulates a file containing names and addresses\n\n";

  address_book.open("h:\\books\\265\\ch10\\progs.imw\\addr.dat",  ios::in );
  //check for errors
  if(!address_book)
    cout << "\nCould not open file\n";

  address_book.seekg(0, ios::end);
  endOfFile = address_book.tellg();
  NoOfRecords = endOfFile / sizeof(data);

  cout << "At the present time there are " << NoOfRecords
       << " records in the file.\n";

  cout << "\n\t\tDo you wish to\n"
       << "\t1\tAdd a Record\n" << "\t2\tRead a Record\n"
       << "\t3\tRead all Records\n" << "\t4\tExit from the Program\n"
       << "\nEnter number: ";
  cin >> select;

  address_book.close();

  return(select);
}

void data::add()
{
  int record, position;
  fstream address_book;

  address_book.open("h:\\books\\265\\ch10\\progs.imw\\addr.dat", ios::app | ios::out );

  //check for errors
  if(!address_book)
    cout << "\nCould not open file\n";

  clrscr();
  enter_data();
  address_book.write((char *) this, sizeof(data) );
  cout << endl << endl << "Press a key to continue ...";
  address_book.close();
  getch();
}

void data::read_rec()
{
  int record, position;
  fstream address_book;

  address_book.open("h:\\books\\265\\ch10\\progs.imw\\addr.dat",  ios::in );

  //check for errors
  if(!address_book)
    cout << "\nCould not open file\n";

  clrscr();
  cout << "Which record do you wish to read? ";
  cin >> record;
  cout << endl << endl;
  position = (record - 1) * sizeof(data);
  address_book.seekg(position);
  address_book.read((char *) this, sizeof(data) );
  display_data();
  cout << endl << endl << "Press a key to continue ...";
  address_book.close();
  getch();
}

void data::read()
{
  int record, position;
  fstream address_book;

  address_book.open("h:\\books\\265\\ch10\\progs.imw\\addr.dat",  ios::in );

  //check for errors
  if(!address_book)
    cout << "\nCould not open file\n";

  clrscr();
  address_book.seekg(0, ios::beg);
  while(address_book)
  {
    address_book.read((char *) this, sizeof(data) );
    if(!address_book.eof())  //to prevent last record being output twice
      display_data();
  }
  cout << endl << endl << "Press a key to continue ...";
  address_book.close();
  getch();
}

void data::enter_data()
{
  cout << "\nEnter first names: ";
  gets(firstnames);
  cout << "Enter surname: ";
  gets(surname);
  cout << "Enter first line of address: ";
  gets(address1);
  cout << "Enter second line of address: ";
  gets(address2);
  cout << "Enter third line of address: ";
  gets(address3);
  cout << "Enter postcode: ";
  gets(postcode);
}

void data::display_data()
{
  cout << endl << firstnames << " " << surname << endl
       << address1 << endl << address2 << endl << address3
       << endl << postcode << endl << endl;
}

void main()
{
  data address;
  int number;

  do
  {
    number = address.menu();

    switch(number)
    {
      case 1:
        address.add();
        break;

      case 2:
        address.read_rec();
        break;

      case 3:
        address.read();
        break;

      case 4:
        clrscr();
        cout << "The program is now ending.";
        break;

      default:
        clrscr();
        cout << "You should enter a number between 1 and 4. Try again.";
        sleep(6);
    }
  }while(number != 4);
}