//      Program 11.1
//      Studying the mountain class

#include <iostream.h>
#include <string.h>

//Class (type) declaration
class mountain                            // class mountain
{
// Private data members:
  char N[21];                             // The mountain name
  int  Height;                            // Height of the mountain

// Private member functions:
  char * GetName();                       // Get name
  int GetHeight();                        // Get height

// Public member functions:
public:
  mountain();                             // Constructor
  void Say(int N);                        // Tell about the mountain

  // The next two functions are overloaded
  void Set(char* n);                      // Set name
  void Set(int h);                        // Set height

  void Copy(mountain M);                  // Copy to this mountain
  mountain Get();                         // Get this mountain
  mountain & GetR();                      // Get reference to this mountain
  mountain * GetP();                      // Get pointer to this mountain

// Friend function:
  friend int cmpM (mountain, mountain);   // Compare 2 mountains
};               // End of class declaration

//Member function definitions
//constructor
mountain::mountain() 
{   //note - no return type specified as this would be an error
  *N = 0;
   Height = 0;
}

//this function, and the others, can be written in this form
/*
  mountain::mountain() {*N=0; Height=0;}
*/

char *   mountain::GetName() {return N;}             // Get name
int      mountain::GetHeight() {return Height;}      // Get height
void     mountain::Set(char* n) {strcpy(N,n);}       // Set name
void     mountain::Set(int h) {Height=h;}            // Set height
void     mountain::Copy(mountain M) {*this=M;}       // Copy to this mountain
mountain mountain::Get() {return *this;}         // Get this mountain
mountain & mountain::GetR() {return *this;}      // Get reference to this
mountain * mountain::GetP() {return this;}       // Get pointer to this

void main ()
{
  mountain E,M2,M3,M4,M5;          // Create (plain) mountains
                                   //   initialized to zero
  E.Say (0);                       // 0.0

  E.Set ("Everest ");              // Set name
  E.Set (8848);                    // Set height
  E.Say (1);                       // 1. Everest 8848

  M2=E;                            // Member by member assignment
  M2.Say (2);
  M3.Copy(E);                      // Copy E to M3
  M3.Say (3);
  
  // E.Get() returns *this, i.e. E
  M4=E.Get();                      // The same as M4=E
  M4.Say(4);
  M4.Get().Say (4);                // The same as M4.Say (4)

  // E.GetR() returns
  //   reference to this (E)
  M5.GetR() = E.GetR();            // The same as M5=E
  M5.Say(5);
  M5.GetR().Say (5);               // The same as M5.Say(5)

  mountain *  pM;                  // Pointer to mountain

  // E.GetP() returns this (&E)
  pM = E.GetP ();                  // The same as pM=&E; 

  // pM points to E (&E)->Say(6);
  pM->Say (6);                     // The same as (&E)->Say(6)
  E.GetP ()->Say (6);              // The same as (&E)->Say(6)

  if (cmpM (M2,E) == 0 && cmpM (M3,E) == 0 &&
      cmpM (M4,E) == 0 && cmpM (M5,E) == 0) 
    cout << "They are all the same!\n";
}

void mountain::Say (int N)
{//      Say about a mountain
  cout << N << ". " << GetName () << Height << endl;
}

int cmpM (mountain M1,mountain M2)
{
/*     Compare the heights of 2 mountains
       friend function of the class mountain
    
`      Returns
      -1 if M1 <  M2
       0 if M1 == M2
      +1 if M1 >  M2
*/

// Access to mountain class private data member
  if(M1.Height < M2.Height)
    return -1;

// Access to mountain class private member function
  if (M1.GetHeight() > M2.GetHeight())
    return +1;

  return 0;
}