//      Program 11.2
//      Function - friend of two classes

#include <iostream.h>
#include <string.h>

class continent;                      // Incomplete declaration

class mountain                        // Class mountain
{
  // Friend function of class mountain
  friend void Say (mountain&, continent&); 

  char N[21];                         // Name of the mountain
public:
  mountain(char *);                   // Constructor
};

class continent                       // Class continent
{
  // Friend function of class continent
  friend void Say (mountain&, continent&);

  char N[21];                         // Name of the continent
public:
  continent(char *);                  // Constructor
  void Say(mountain&, continent&);    // Member function
};

//      Constructors definitions

  mountain::mountain(char * N) {strcpy (mountain::N,N);}
  continent::continent(char * N) {strcpy (continent::N,N);}

//      ------------------------------------------------------

void Say(mountain& M, continent& C)
{
/*  Say about a mountain and a continent

    This global function, which is a friend function of classes mountain 			 and continent, can access all members of both classes
*/

  cout << M.N << C.N << endl;

// Error: Field N cannot be used without an object
// cout << mountain::N << continent::N << endl;
}

//      ------------------------------------------------------

void continent::Say(mountain& M,continent& C)
{
/*  Say about a mountain and a continent

    continent class member function can call any global function, including a friend.
    To avoid name ambiguity we must use the scope resolution operator (::)
*/

  ::Say (M,C);    // Call Say() defined in global scope

/*  Say (M,C); would cause an error: call member continent::Say(),
    i.e. itself, which would result in the endless loop.
*/
}

void main ()
{
  mountain E = "Everest ";        // Using constructor with one argument
  continent C = "Asia ";          // for type conversion

  Say (E,C);                      // Call the friend function
  C.Say (E,C);                    // Call the member function
}