//  calc1.cpp
//  using class number to implement a simple calculator

#include <iostream.h>             //header file for I/O
#include <math.h>                 //header file for library sqrt()

class number                      //class number
{
public:                           //public members
  number()                        //constructor initializes data to 0.0
  {
	  val = 0.0;
  }

  number(double n)                //constructor that assigns a double to object
  {
	  val = n;
  };

  //functions
  void sqrt(void)                  //member sqrt()
  {
	  if(val <= 0)                   //if val is less than 0, output message
	  {
	    cout << "The square root of a negative number is not"
		  << " a suitable calculation.";
	  }
	  else                           //pass val to library function and store
	  {                              //answer in our Z.
	    number Z;
	    Z.val = ::sqrt(val);
	    Z.say();                     //display answer
	  }
  }

  void say(void)                   //display data on screen
  {
 	  cout << val << endl;
  }

  void operator= (double d)        //overloaded assignment operator
  {
	  val = d;
  }

private:                              //private members
  double val;                         //double used for size of numbers
  				      //   and precision

  friend void operator+ (number& X, number& Y);
  friend void operator- (number& X, number& Y);
  friend void operator* (number& X, number& Y);
  friend void operator/ (number& X, number& Y);
  friend void operator% (number& X, number& Y);
};

//overloaded operators

void operator+ (number& X, number& Y)
{
  number Z;
  Z.val = X.val + Y.val;
  Z.say();
}

void operator- (number& X, number& Y)
{
  number Z;
  Z.val = X.val - Y.val;
  Z.say();
}

void operator* (number& X, number& Y)
{
  number Z;
  Z.val = X.val * Y.val;
  Z.say();
}

void operator/ (number& X, number& Y)
{
  number Z;
  if(Y.val == 0.0)
	cout << "\tAttempt to Divide by 0";
  else
  {
	Z.val = X.val / Y.val;
	Z.say();
  }
}

void operator% (number& X, number& Y)
{
  number Z;
  if(X.val == 0.0)
	Z.say();
  else
	if(Y.val == 0.0)
	  Z.say();
	else
	{
	  Z.val = X.val * Y.val / 100.00;
	  Z.say();
	}
}

//objects
number X, Y, Z;

void main()
{
  char choice, select = 'Y';

  //function prototype
  void enter_data(char ch);

  do                               //do until user has no more calculations
  {                                //  to do
	   do                            //do display menu and call functions until
	   {                             //  user wishes to Finish
	     cout << "\n\tSimple Calculator" << "\n\n\tOptions"
           << "\n\t+\tAddition" << "\n\t-\tSubtraction"
		  << "\n\t*\tMultiplication" << "\n\t/\tDivision"
		  << "\n\t%\tPercentage" << "\n\tR\tSquare Root"
		  << "\n\tF\tFinish" << "\n\n\tEnter Option: ";

	     cin >> choice;              //obtain users choice

	     switch(choice)              //select options via switch
	     {
		case '+':                 //addition
		  enter_data(choice);
		  X + Y;
		  break;
		case '-':                 //subtraction
		  enter_data(choice);
		  X - Y;
		  break;
		case '*':                 //multiplication
		  enter_data(choice);
		  X * Y;
		  break;
		case '/':                 //division
		  enter_data(choice);
		  X / Y;
		  break;
		case '%':                 //percentage
		  enter_data(choice);
		  X % Y;
		  break;
		case 'R':                 //square root - if R entered
		case 'r':                 //square root - ir r entered
		  enter_data(choice);
		  X.sqrt();
		  break;
		case 'F':                 //finish - if F entered
		case 'f':                 //finish - if f entered
		  select = 'N';
		  break;
		default:                  //default - in case invalid choice made
		  cout << "\n\tYou have made an invalid choice\n";
		  select = 'N';
	     }
	   }while (select == 'Y'); //loop continues until select is changed to N

	   if (choice != 'f' && choice != 'F')     //if not Finish, ask question
	   {
	      cout << "\n\n\tDo you want another go? (Y/N): ";
	      cin >> choice;
	   }

  } while(choice != 'n' && choice != 'N' && choice != 'f' && choice != 'F');
}

//non-member function declaration

void enter_data(char ch)
{
	double number1 = 0.0, number2 = 0.0;

	cout << "\n\tEnter number: ";
	cin >> number1;

	if(ch != 'r' && ch != 'R')
	{
	  cout << "\tEnter number: ";
	  cin >> number2;
	}

	X = number1, Y = number2;

	if(ch != 'r' && ch != 'R')
	{
	  cout << "\n\n\t" << number1 << " " << ch
		   << " " << number2 << " = ";
	}
	else
	  cout << "\n\n\t*" << number1 << " = ";
}
