//  Program 16.5
//  Draw line, filled polygon

#include "h:\books\265\ch16\progs.imw\P16-04.h"

int main()
{
  if (! Init ())          // Initialize graphics system
    return 1;             // Exit on error

  const int MaxX    = getmaxx ();
  const int MaxY    = getmaxy ();
  const int MaxColor = getmaxcolor ();

//      Line between two points: line ()

  int Color  = MaxColor, X1 = 0, Y1 = 0, X2 = MaxX, Y2 = MaxY;

  setcolor (Color);       // Set draw color
  line (X1,Y1, X2,Y2);    // Diagonal line from left top
  Pause ();               //   to right bottom screen corner

//      Move current position (CP): moveto ()

  cleardevice ();

  cout    << "\n Before moveto ()" << "\n Current X = " << getx ()
          << "\n Current Y = " << gety ();
 
  moveto (MaxX,MaxY);                     // Move CP

  cout    << "\n After moveto (MaxX,MaxY)" << "\n Current X = " << getx ()
          << "\n Current Y = " << gety ();
  Pause ();

//      Line from current position: lineto ()

  int X=MaxX/6, Y=MaxY/6;

  cleardevice ();
  setcolor (Color);       // Set draw color

  moveto (  0,Y*5);       // Go to new CP
                          // Two peak mountain ( /\/\ )
  lineto (X*2,Y*1);       // Line 1
  lineto (X*3,Y*2);       // Line 2
  lineto (X*4,Y*1);       // Line 3
  lineto (X*6,Y*5);       // Line 4
  lineto (  0,Y*5);       // Line 5
  Pause ();

//      Fill bounded region: floodfill ()

  int FillColor   = Color;
  int BorderColor = Color;

  setcolor (Color);                       // Set draw color
  setfillstyle (SOLID_FILL,FillColor);    // Set fill color
  floodfill (MaxX/2,MaxY/2,BorderColor);  // Fill enclosed area Pause ();

//      Fill polygon: fillpoly ()

  int Shape [] = { 0,16, 3,14, 6,10, 8,6, 10,8, 12,4, 16,12, 20,16 };
  int NPoints = sizeof Shape / sizeof (int) / 2;
  int     i,j;

  for (i=j=0; i<NPoints; i++,j+=2) 
  {
    Shape[j]   = Shape[j] * MaxX / 20;
    Shape[j+1] = Shape[j+1] * MaxY / 20;
  }

  cleardevice ();
  setcolor (Color);                       // Set draw color
  FillColor = Color;
  setfillstyle (SOLID_FILL,FillColor);    // Set fill color
  fillpoly (NPoints,Shape);               // Draw and fill
  Pause ();

  closegraph ();
}