//  Program 16.8
//  Text justification and size

#include "h:\books\265\ch16\progs.imw\P16-04.h"

void DrawCP();

int main()
{
  if (! Init ())          // Initialize graphics system
    return 1;             // Exit on error

  const int MaxX    = getmaxx ();
  const int MaxY    = getmaxy ();
  const int MaxColor= getmaxcolor ();

//      Text justification

  int Color = MaxColor, HorizJust = CENTER_TEXT, VertJust  = CENTER_TEXT;

  setcolor (Color);
  moveto (MaxX/2,MaxY/2);
  DrawCP();                              // Draw +  at the CP

  settextstyle (TRIPLEX_FONT,HORIZ_DIR,1);
  settextjustify (HorizJust,VertJust); 
  outtext ("C     +");                    // Centered text

  settextstyle (TRIPLEX_FONT,VERT_DIR,1); 
  outtext ("C     +");                    // Vertical text
  Pause ();

//      9 justification styles

  struct  Justification 
  {
    int  Horizontal;
    int  Vertical;
    char *  Text;
  };

  settextstyle (TRIPLEX_FONT,HORIZ_DIR,1);

  Justification J [] = { 
                      LEFT_TEXT,   BOTTOM_TEXT, "LEFT_TEXT   BOTTOM_TEXT",
                      LEFT_TEXT,   CENTER_TEXT, "LEFT_TEXT   CENTER_TEXT",
                      LEFT_TEXT,   TOP_TEXT,    "LEFT_TEXT   TOP_TEXT",
                      CENTER_TEXT, BOTTOM_TEXT, "CENTER_TEXT BOTTOM_TEXT",
                      CENTER_TEXT, CENTER_TEXT, "CENTER_TEXT CENTER_TEXT",
                      CENTER_TEXT, TOP_TEXT,    "CENTER_TEXT TOP_TEXT",
                      RIGHT_TEXT,  BOTTOM_TEXT, "RIGHT_TEXT  BOTTOM_TEXT",
                      RIGHT_TEXT,  CENTER_TEXT, "RIGHT_TEXT  CENTER_TEXT",
                      RIGHT_TEXT,  TOP_TEXT,    "RIGHT_TEXT  TOP_TEXT"
                       };

  for (int i=0; i<9; i++) 
  {
    cleardevice ();
    setcolor (Color);
    settextjustify (J[i].Horizontal,J[i].Vertical);

    moveto (MaxX/2,MaxY/2);
    DrawCP ();                    // Draw +  at the CP
    outtext (J[i].Text);
    Pause ();
  }

//      Text size

  cleardevice ();
  setcolor (Color);
  moveto (MaxX/2,MaxY/2);
  settextjustify (CENTER_TEXT,CENTER_TEXT);
  settextstyle (TRIPLEX_FONT,HORIZ_DIR, 4 );   
  outtext ("Hello, C++ Programmer !");            // Large text Pause ();

  closegraph ();
}

void  DrawCP() 
{
//      Draw + at current position
  
  int X = getx ();
  int Y = gety ();

  line(X-10, Y,    X+10, Y);     // Horizontal line
  line(X,    Y-10, X,    Y+10);  // Vertical line
}